/* 페이징 관련 변수 */
let webEventTotalCount   = 0;
let webEventTotalPages   = 0;

/*aggird*/
let webEventAgGridData = [];

let webEventSelectId = "";

/****************************************************************************
 * 검색 날짜 설정
 //(A:오늘, B:3일, C:7일, D:최근30일, E:최근90일, F:이번달, G:올해, H:지난주, I:지난달)
 ****************************************************************************/
function fn_webEventSetDate(param){
    if("A"==param){
        // 오늘
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchStartDate = year+'-'+month+'-'+day;
        webEventSearchEndDate   = year+'-'+month+'-'+day;
    }
    else if("B"==param){
        // 3일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 3);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("C"==param){
        // 이번주
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 7);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("D"==param){
        // 최근30일
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        //최근30일
        toDate.setDate(toDate.getDate() - 30);
        startYear  = toDate.getFullYear();
        startMonth = toDate.getMonth() + 1;
        startDay   = toDate.getDate();

        if(startMonth < 10) startMonth = "0" + startMonth;
        if(startDay < 10) startDay = "0" + startDay;

        webEventSearchStartDate = startYear+'-'+startMonth+'-'+startDay;
        webEventSearchEndDate   = year+'-'+month+'-'+day;

    }
    else if("E"==param){
        // 최근90일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 90);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("F"==param){
        //F:이번달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webEventSearchStartDate = year+'-'+month+'-01';
    }
    else if("G"==param){
        // G:올해
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webEventSearchStartDate = year+'-01-01';
    }
    else if("H"==param){
        // H:지난주, I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webEventSearchStartDate = year+'-01-01';
    }
    else if("I"==param){
        // I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webEventSearchStartDate = year+'-01-01';
    }

    $("#webEventSearchStartDate").val(webEventSearchStartDate).trigger("change");
    $("#webEventSearchEndDate").val(webEventSearchEndDate).trigger("change");
}


/****************************************************************************
 * 이벤트 정보 리스트 조회
 ****************************************************************************/
function fn_selectListWebEventJson(){
    let formData = new FormData();
    formData.append("menuClass", menuClass);
    formData.append("webEventSearchKeywordParam", webEventSearchKeywordParam);
    formData.append("webEventSort", webEventSort);
    formData.append("webEventDir", webEventDir);
    formData.append("webEventStart", webEventStart);
    formData.append("webEventLimit", webEventLimit);
    formData.append("webEventSearchStartDate", webEventSearchStartDate);
    formData.append("webEventSearchEndDate", webEventSearchEndDate);
    formData.append("webEventSearchDateType", webEventSearchDateType);

    $.ajax({
        url: encodeURI('/webevent/selectListWebEvent.do'),
        data: formData,
        dataType: "json",
        processData: false,
        contentType: false,
        type: 'POST',
        async: true,
        success: function(data){
            if('0'==data.msgCode){
                // 페이징 처리
                webEventTotalCount  = data.totalCount;
                //$("#txt_noticeTotalCount").text(noticeTotalCount);

                webEventTotalPages = Math.ceil(webEventTotalCount/webEventLimit);

                // 리스트 조회
                webEventAgGridData = data.rows;
                webEventGridOptions.api.setRowData(webEventAgGridData);

                if(0<data.rows.length){
                    //페이징 처리
                    window.pagObj = $('#webEventPagination').twbsPagination({
                        startPage    : ((webEventStart/webEventLimit)+1),
                        totalPages   : (webEventTotalPages==0)?1:webEventTotalPages,
                        visiblePages : 10,
                        initiateStartPageClick: false,
                        prev         : '<img src="/image/web/page_navigation_arrow.svg" alt="prev"/>',
                        next         : '<img src="/image/web/page_navigation_arrow.svg" alt="next"/>',
                        first        : '',
                        last         : '',
                        onPageClick: function (event, page) {
                            fn_webEventPagination(page);
                        }
                    }).on('page', function (event, page) {
                        //console.info(page + ' (from event listening)');
                    });
                }
                else{

                }
            }
            else{
                modalEvent.danger("조회 오류", data.msgDesc);
            }
        },
        error : function(xhr, status, error) {
            modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
        },
        beforeSend:function(){
            // 로딩열기
            webEventGridOptions.api.showLoadingOverlay();
        },
        complete:function(){

        }
    });
}

/****************************************************************************
 * 검색하기
 ****************************************************************************/
function fn_webEventSearch(param){
    if("A"!=param && "Y"!=selectUseYn){
        modalEvent.warning("", "조회 권한이 없습니다.");
        return false;
    }

    fn_webEventPaginReset();

    webEventSearchKeywordParam = $("#webEventSearchKeyword").val();

    webEventSearchDateType  = $("#webEventSearchDateType").val();
    webEventSearchStartDate = $("#webEventSearchStartDate").val();
    webEventSearchEndDate   = $("#webEventSearchEndDate").val();

    fn_selectListWebEventJson();
}


/****************************************************************************
 * 초기화하기
 ****************************************************************************/
function fn_webEventReset(){
    fn_webEventSetDate('D');
    $("#webEventSearchDateType option:eq(0)").prop("selected", true);

    $("#webEventSearchKeyword").val("");

    fn_webEventSearch();
}

/****************************************************************************
 * 페이징 처리
 ****************************************************************************/
function fn_webEventPagination(param){
    webEventStart = (parseInt(param)-1)*webEventLimit;

    fn_selectListWebEventJson();
}

/****************************************************************************
 * 페이징 리셋
 ****************************************************************************/
function fn_webEventPaginReset(){
    webEventSearchKeywordParam = '';

    webEventStart        = 0;
    webEventLimit        = 100;
    webEventTotalCount   = 0;
    webEventTotalPages   = 0;

    //페이징 초기화
    if($("#webEventPagination").data("twbs-pagination")){
        $("#webEventPagination").twbsPagination("destroy");
    }
}

/****************************************************************************
 * 이벤트 삭제
 ****************************************************************************/
function fn_deleteWebEvent(){
    if("Y"!=deleteUseYn){
        modalEvent.warning("", "삭제 권한이 없습니다.");
        return false;
    }

    if(!webEventSelectId){
        modalEvent.warning("", "삭제할 대상을 선택하세요.");
        return false;
    }

    modalEvent.info("삭제", "선택한 이벤트 정보를 삭제하시겠습니까?", function(){
        let formData = new FormData();
        formData.append("menuClass", menuClass);
        formData.append("selectId", webEventSelectId);

        $.ajax({
            url: encodeURI('/webevent/deleteWebEvent.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function(data){
                if('0'==data.msgCode){
                    modalEvent.success("삭제 성공", data.msgDesc, function(){
                        fn_webEventOk();
                    });
                }
                else{
                    modalEvent.danger("삭제 오류", data.msgDesc);
                }
            },
            error : function(xhr, status, error) {
                modalEvent.danger("삭제 오류", "삭제 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
            },
            beforeSend:function(){

            },
            complete:function(){

            }
        });
    });
}

/****************************************************************************
 * 검색 엔터 이벤트
 ****************************************************************************/
function fn_webEventEnter(e){
    if(e.which){
        // 파이어폭스
        if(13 == e.which) {
            //로그인 액션 스크립트
            fn_webEventSearch();
        }
    }
    else{
        // 윈도우, 사파리, 크롬
        if(13 == event.keyCode) {
            //로그인 액션 스크립트
            fn_webEventSearch();
        }
    }
}

/****************************************************************************
 * 정렬 이벤트
 ****************************************************************************/
function fn_alignEvent(param, param2){
    let align = "";

    if("A"==param){
        align = "오늘";

        fn_webEventSetDate('A');
    }
    else if("B"==param){
        align = "최근30일";

        fn_webEventSetDate('D');
    }
    else if("C"==param){
        align = "최근90일";

        fn_webEventSetDate('E');
    }
    else if("D"==param){
        align = "이번주";

        fn_webEventSetDate('C');
    }
    else if("E"==param){
        align = "이번달";

        fn_webEventSetDate('F');
    }
    else if("F"==param){
        align = "올해";

        fn_webEventSetDate('G');
    }
    else if("G"==param){
        align = "지난주";

        fn_webEventSetDate('H');
    }
    else if("H"==param){
        align = "지난달";

        fn_webEventSetDate('I');
    }
    else{
        align = "";
    }
    $("#webEventSearchDateType").val(param);
    $("#webEventSearchDateType").siblings("button").text(align);
}

/****************************************************************************
 * 완료
 ****************************************************************************/
function fn_webEventOk(){
    fn_webEventReset();
}

/****************************************************************************
 * 등록 화면으로 이동.
 ****************************************************************************/
function fn_insertWebEventIntro(){
    if("Y"==insertUseYn){
        let pagingParam = "?menuClass="+menuClass;
        fn_leftFormAction("/webevent/insertWebEventIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "등록 권한이 없습니다.");
        return false;
    }

}

/****************************************************************************
 * 수정 화면으로 이동.
 ****************************************************************************/
function fn_updateWebEventIntro(muWebEventId){
    if("Y"==updateUseYn){
        let pagingParam = "?menuClass="+menuClass;
        pagingParam    += "&muWebEventId="+muWebEventId;
        fn_leftFormAction("/webevent/updateWebEventIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "수정 권한이 없습니다.");
        return false;
    }
}


let webEventColumnDefs = [
    {field: "checkbox", headerName:"", minWidth:55, maxWidth:55, headerCheckboxSelection: true, checkboxSelection: true},
    /* {field: "rowNum", headerName:"번호", minWidth:80,maxWidth:80, sortable: false}, */
    {field: "rowNum", headerName:"번호", minWidth:60, maxWidth:60,sortable: false, cellStyle:{textAlign: 'center'}},
    {field: "title", headerName:"제목", minWidth:250, cellStyle:{cursor: 'pointer', color:'#3985EA'}},
    // {field: "content", headerName:"내용",minWidth:500},
    {field: "eventDate", headerName:"기간",minWidth:250, maxWidth:250},
    {field: "writeDate", headerName:"등록일",minWidth:150, maxWidth:150},
    {field: "writeName", headerName:"작성자",minWidth:150, maxWidth:150},
];

// let the grid know which columns and what data to use
let webEventGridOptions = {
    suppressRowTransform: true,
    columnDefs: webEventColumnDefs,
    defaultColDef: {		// 리스트 기본 설정
        flex: 1,
        sortable: true,		//정렬 여부
        resizable: true,	//리사이즈
        editable: true,	// 그리드에서 데이터 수정
        cellStyle:{textAlign:'left',fontSize:'14px',padding:'0'},
        //suppressSizeToFit:true,		//자동 맞춤
        //enableRowGroup: true,		// 그룹 묶음
        enablePivot: true,
        enableValue : true
    },
    //suppressMultiSort:true,  //단일솔트 true가 단일, false가 다중 shift + sort 시
    headerHeight : 41, // header 높이
    rowHeight : 41, // row 높이
    rowData : webEventAgGridData,
    suppressRowClickSelection : true, // 로우 클릭시 체크박스 선택 true no, false yes
    localeText : {
        noRowsToShow : '조회 결과가 없습니다.'
    }, //데이터 없을 시 나오는 문구
    rowSelection : 'multiple', // row 다중 선택
    debug : false,
    onCellClicked: function(event){ //셀 클릭 이벤트
        /* alert(event.column.colId); */
        if('title'==event.column.colId){
            fn_updateWebEventIntro(event.data.muWebEventId);
        }
    },
    onSelectionChanged: function(event){ //체크박스 선택
        let selectRows = [];
        selectRows = event.api.getSelectedRows();

        webEventSelectId = '';
        for(let i=0; i<selectRows.length; i++){
            webEventSelectId += selectRows[i].muWebEventId + ",";
        }
        webEventSelectId = webEventSelectId.substring(0, webEventSelectId.lastIndexOf(','));
    },
    onSortChanged: function(event){
        //정렬
        webEventSort = ''; //기존 정렬 초기화
        let columnArr = event.columnApi.getColumnState();
        if(0<columnArr.length){
            //sort index 순으로 재정렬
            columnArr.sort(function(a,b){
                return a.sortIndex - b.sortIndex;
            });

            let nullCnt = 0;
            for(let i=0; i<columnArr.length; i++){
                let gridSortModel = columnArr[i].colId;
                let gridSort = columnArr[i].sort;

                if(gridSort != null){
                    webEventStart = 0;
                    webEventSort += gridSortModel+' '+ gridSort + ',';
                }
                else{
                    nullCnt++;
                    if(nullCnt == columnArr.length){
                        webEventSort = '';
                        webEventDir = '';
                        webEventStart = 0;
                    }
                }
            }
        }
        webEventSort = webEventSort.substring(0,webEventSort.lastIndexOf( ",")); //맨끝 콤마 지우기

        fn_webEventSearch();
    }
};

// lookup the container we want the Grid to use
let webEventGridDiv = document.querySelector('#webEventGrid');

// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(webEventGridDiv, webEventGridOptions);





/****************************************************************************
 * 페이지 init
 ****************************************************************************/
function fn_pageInit(){
    // 날짜 datepicker
    fn_searchDatePicker("#divWebEventSearchStartDate", "#divWebEventSearchEndDate");

    if(!webEventSearchStartDate&&!webEventSearchEndDate){
        // 검색 오늘날짜 셋팅
        fn_webEventSetDate('D');
    }else{
        $("#webEventSearchStartDate").val(webEventSearchStartDate).trigger("change");
        $("#webEventSearchEndDate").val(webEventSearchEndDate).trigger("change");
    }

    // 초기 페이징 처리
    $("#webEventSearchKeyword").val(webEventSearchKeywordParam);

    fn_webEventSearch("A");
}

/****************************************************************************
 * 페이지 event
 ****************************************************************************/
function fn_pageEvent(){
    // 검색 input
    $(document).on('keypress', '#webEventSearchKeyword', function(e) {
        fn_webEventEnter(e);
    });

    // 검색 조회 버튼
    $("#btnSearchWebEvent").click(function () {
        fn_webEventSearch();
    });

    // 이벤트 등록 팝업 버튼
    $("#btnInsertWebEvent").click(function () {
        fn_insertWebEventIntro();
    });

    // 이벤트 삭제 버튼
    $("#btnDeleteWebEvent").click(function () {
        fn_deleteWebEvent();
    });

    // 기간 선택 콤보 이벤트
    const target = $("#webEventSearchDateType").siblings("ul.select_option_list");
    target.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);

        fn_alignEvent(selectId);
    });
}

$(function(){
    // 페이지 init
    fn_pageInit();

    // 페이지 event
    fn_pageEvent();
});